##############################################################

# power test, same-size clusters



#setwd("J:/Justin Esarey/Desktop/Complete Replication File/2015-6-3_linear_FE_acor_strong_results")
setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/2015-6-3_linear_FE_acor_strong_results")
rm(list=ls())
source(file="clusterIM.glm.R", echo=F)
source(file="clusterwild.plm.R", echo=F)
source(file="clusterBS.plm.R", echo=F)
source(file="2015-6-3_cluster_linear_power.R", echo=F)

set.seed(387218)
clusterIMtestLinear(obs.per.cluster = rep(40, 3), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 6), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 15), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 21), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 30), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 60), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 75), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 90), g.sd = 1, reps=1000)
clusterIMtestLinear(obs.per.cluster = rep(40, 120), g.sd = 1, reps=1000)

cl.n <- c(3, 6, 15, 21, 30, 60, 75, 90, 120)

vn.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
cl.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
mx.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
im.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
wd.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.v <- matrix(data=NA, nrow=length(cl.n), ncol=3)
bs.result.c <- matrix(data=NA, nrow=length(cl.n), ncol=3)
re.result <- matrix(data=NA, nrow=length(cl.n), ncol=3)


im.nonconverge <- c()
re.nonconverge <- c()

for(i in 1:length(cl.n)){
  load(paste("power-linear-fe-acor-clusters-", cl.n[i],"_unique-1_sd-1.RData", sep=""))
  vn.result[i,] <- colSums(list.out[[3]] < 0.05) / 1000
  cl.result[i,] <- colSums(list.out[[4]] < 0.05) / 1000
  mx.result[i,] <- colSums(list.out[[5]] < 0.05) / 1000
  im.result[i,] <- colSums(list.out[[6]] < 0.05, na.rm = T) / colSums(is.na(list.out[[6]])==F)
  wd.result[i,] <- colSums(list.out[[7]] < 0.05) / 1000
  bs.result.v[i,] <- colSums(list.out[[8]] < 0.05) / 1000
  bs.result.c[i,] <- colSums(list.out[[9]] < 0.05) / 1000
  re.result[i,] <- colSums(list.out[[10]] < 0.05) / colSums(is.na(list.out[[10]])==F)
  
  
  # proportion of non-converged results
  im.nonconverge[i] <- colSums(is.na(list.out[[6]]))[1] / 1000
  re.nonconverge[i] <- colSums(is.na(list.out[[10]]))[1] / 1000
  
  
}

im.nonconverge
re.nonconverge

# source for textual note about CAT power
im.result
# 21 clusters, 21*40 = 840 observations
cl.n[4]
im.result[4,]


plot(vn.result[,1] ~ cl.n, type = "l", ylim = c(0, 1), xlab = "number of clusters", ylab = "prop. of rejected null hypotheses", main = c("Regression True Positive Rates (cluster size = 40)", "Cluster-Correlated Independent Variable"))

lines(bs.result.v[,1] ~ cl.n, lty=1, lwd=3, col="darkgray")
lines(bs.result.c[,1] ~ cl.n, lty=2, lwd=3, col="darkgray")
lines(cl.result[,1] ~ cl.n, lty=2)
lines(im.result[,1] ~ cl.n, lty=4, lwd=2)
lines(wd.result[,1] ~ cl.n, lty=3, lwd=2)
lines(re.result[,1] ~ cl.n, lwd=2)

legend("bottomright", lty=c(1,2,4,3,1,2,1), lwd=c(1,1,2,2,3,3,2), col=c(rep("black",4), "darkgray", "darkgray"), legend=c("vanilla SEs", "CRSEs", "CATs", "WCBSTs", "PCBSTs, vanilla replicates", "PCBSTs, CRSE replicates", "Random Effects"))

dev.copy2pdf(file="linear-power-corr-strong.pdf")