# alternate analysis using R package

setwd("J:/Dropbox/jesarey_documents/Clustering Project with Andrew/Complete Replication File/Hainmuller Replication")

rm(list=ls())
source(file="clusterBS.plm.R")

library(foreign)
dat <- read.dta("hain-dat-r.dta")

library(plm)
dat.p <- plm.data(dat, indexes=c("storeprod", "periodfw"))


# cluster bootstrap results
# not exactly the same as in paper; clustering is on store-product, not store
fe.mod <- plm(delta ~ salesp + FRCB, effect="twoways", model="within", data=dat.p)
cluster.bs.plm(mod=fe.mod, dat=dat.p, cluster="group", ci.level = 0.95, boot.reps = 1000, cluster.se = TRUE, report = TRUE, prog.bar = TRUE)

# CRSE results
# also not exactly the same; clustering on store-product, not store
coeftest(fe.mod, vcovHC(fe.mod, method="arellano", type="HC0", cluster="group"))

# Ibragimov-Muller SEs (same as in Table 3, Column 3)
glm.mod <- glm(delta ~ salesp + FRCB + perdum2 + perdum3 + perdum4 + perdum5 + perdum6 + perdum7 + perdum8 + itemdum2 + itemdum3 + itemdum4 + itemdum5 + itemdum6 + itemdum7, data=dat)
source("clusterIM.glm.R")
cluster.im.glm(glm.mod, dat, ~store, drop=F)

